// PrintMyChartView.cpp : implementation of the CPrintMyChartView class
//

#include "stdafx.h"
#include "PrintMyChart.h"

#include "PrintMyChartDoc.h"
#include "PrintMyChartView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintMyChartView

IMPLEMENT_DYNCREATE(CPrintMyChartView, CFormView)

BEGIN_MESSAGE_MAP(CPrintMyChartView, CFormView)
	//{{AFX_MSG_MAP(CPrintMyChartView)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrintMyChartView construction/destruction

CPrintMyChartView::CPrintMyChartView()
	: CFormView(CPrintMyChartView::IDD)
{
	//{{AFX_DATA_INIT(CPrintMyChartView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CPrintMyChartView::~CPrintMyChartView()
{
}

void CPrintMyChartView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrintMyChartView)
	DDX_Control(pDX, IDC_MSCHART, m_chart);
	//}}AFX_DATA_MAP
}

BOOL CPrintMyChartView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CPrintMyChartView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CPrintMyChartView printing

BOOL CPrintMyChartView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// make preparation to print

	// order chart to copy itself onto clipboard
	m_chart.EditCopy();

	// make sure the item in clipboard is a bitmap
	if(IsClipboardFormatAvailable(CF_BITMAP))
	{
		if(OpenClipboard())
		{
			m_hbitmap = (HBITMAP)::GetClipboardData(CF_BITMAP);
			CloseClipboard();
		}
	}

	return DoPreparePrinting(pInfo);
}

void CPrintMyChartView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPrintMyChartView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CPrintMyChartView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	// Create a text for the title
	CString sTitleHeader=_T("My First Chart");

	// Get the page size and boundaries
	CRect rectPage = pInfo->m_rectDraw;

	TEXTMETRIC tm;
	CFont font;
	CSize textSize;
	int cyChar;

	// Create the font we will be using
	font.CreatePointFont(240, "Arial", pDC);
	CFont *pOldFont=pDC->SelectObject(&font);

	//Set Margin
	rectPage.top+=rectPage.bottom/48;
	rectPage.bottom-=rectPage.bottom/48;
	rectPage.left+=200;
	rectPage.right-=200;

	// Get Text size in order to center
	pDC->GetTextMetrics(&tm);
	textSize=pDC->GetTextExtent(sTitleHeader);
	cyChar = tm.tmHeight;


	// Draw Text (centered)
	pDC->TextOut(((rectPage.right+rectPage.left)/2)-(textSize.cx/2), rectPage.top, sTitleHeader);
	rectPage.top += cyChar + cyChar / 4;

	// Draw header line divider
	pDC->MoveTo(rectPage.left, rectPage.top);
	pDC->LineTo(rectPage.right, rectPage.top);

	// Go to next line
	rectPage.top += cyChar / 4;

	if(m_hbitmap)
	{
		BITMAP bm;
		::GetObject(m_hbitmap, sizeof(BITMAP), &bm);
		CSize chartSize(bm.bmWidth, bm.bmHeight);

		CDC dcMemory,dcScreen;
		dcScreen.Attach(::GetDC(NULL));

		// create "from" device context and select the loaded bitmap into it
		dcMemory.CreateCompatibleDC(&dcScreen);
		dcMemory.SelectObject(m_hbitmap);

		// Print at 85% size within left/right margin 
		CSize printSize;
		printSize.cx=(int)(rectPage.right*.85);
		printSize.cy=printSize.cx/chartSize.cx*chartSize.cy;

		// Print chart centered
		pDC->StretchBlt( ((rectPage.right+rectPage.left)/2)-(printSize.cx/2), rectPage.top, printSize.cx, printSize.cy, &dcMemory, 0, 0, chartSize.cx, chartSize.cy, SRCCOPY);
		dcMemory.DeleteDC();
	}

	// Revert and Destroy
	pDC->SelectObject(pOldFont);
	font.DeleteObject();

}

/////////////////////////////////////////////////////////////////////////////
// CPrintMyChartView diagnostics

#ifdef _DEBUG
void CPrintMyChartView::AssertValid() const
{
	CFormView::AssertValid();
}

void CPrintMyChartView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CPrintMyChartDoc* CPrintMyChartView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPrintMyChartDoc)));
	return (CPrintMyChartDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPrintMyChartView message handlers
